// This file is part of Substrate.

// Copyright (C) 2022 Parity Technologies (UK) Ltd.
// SPDX-License-Identifier: Apache-2.0

// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

//! Autogenerated weights for pallet_file_bank
//!
//! THIS FILE WAS AUTO-GENERATED USING THE SUBSTRATE BENCHMARK CLI VERSION 4.0.0-dev
//! DATE: 2022-06-14, STEPS: `1`, REPEAT: 1, LOW RANGE: `[]`, HIGH RANGE: `[]`
//! EXECUTION: Some(Wasm), WASM-EXECUTION: Compiled, CHAIN: Some("cess-staking-testnet"), DB CACHE: 1024

// Executed Command:
// ./target/release/cess-node
// benchmark
// --chain
// cess-staking-testnet
// --execution=wasm
// --wasm-execution=compiled
// --pallet
// pallet_file_bank
// --extrinsic
// *
// --steps
// 1
// --repeat
// 1
// --template=./.maintain/frame-weight-template.hbs
// --output=./c-pallets/file-bank/src/weights_demo.rs

#![cfg_attr(rustfmt, rustfmt_skip)]
#![allow(unused_parens)]
#![allow(unused_imports)]

use frame_support::{traits::Get, weights::{Weight, constants::RocksDbWeight}};
use sp_std::marker::PhantomData;

/// Weight functions needed for pallet_file_bank.
pub trait WeightInfo {
	fn upload() -> Weight;
	fn upload_filler(v: u32, ) -> Weight;
	fn update_dupl() -> Weight;
}

/// Weights for pallet_file_bank using the Substrate node and recommended hardware.
pub struct SubstrateWeight<T>(PhantomData<T>);
impl<T: frame_system::Config> WeightInfo for SubstrateWeight<T> {
	// Storage: FileBank UserHoldSpaceDetails (r:1 w:1)
	// Storage: FileBank File (r:1 w:1)
	// Storage: FileBank UserHoldFileList (r:1 w:1)
	// Storage: FileBank Invoice (r:0 w:1)
	fn upload() -> Weight {
		(60_499_000 as Weight)
			.saturating_add(T::DbWeight::get().reads(3 as Weight))
			.saturating_add(T::DbWeight::get().writes(4 as Weight))
	}
	// Storage: FileMap SchedulerMap (r:1 w:0)
	// Storage: Sminer MinerDetails (r:1 w:0)
	// Storage: FileBank FillerMap (r:0 w:100)
	fn upload_filler(_v: u32, ) -> Weight {
		(349_694_000 as Weight)
			.saturating_add(T::DbWeight::get().reads(2 as Weight))
			.saturating_add(T::DbWeight::get().writes(100 as Weight))
	}
	// Storage: FileBank File (r:1 w:1)
	// Storage: Sminer MinerDetails (r:1 w:1)
	// Storage: Sminer MinerItems (r:1 w:1)
	// Storage: Sminer TotalSpace (r:1 w:1)
	// Storage: Sminer AllMiner (r:1 w:1)
	// Storage: FileBank FillerMap (r:1 w:0)
	fn update_dupl() -> Weight {
		(163_897_000 as Weight)
			.saturating_add(T::DbWeight::get().reads(6 as Weight))
			.saturating_add(T::DbWeight::get().writes(5 as Weight))
	}
}

// For backwards compatibility and tests
impl WeightInfo for () {
	// Storage: FileBank UserHoldSpaceDetails (r:1 w:1)
	// Storage: FileBank File (r:1 w:1)
	// Storage: FileBank UserHoldFileList (r:1 w:1)
	// Storage: FileBank Invoice (r:0 w:1)
	fn upload() -> Weight {
		(60_499_000 as Weight)
			.saturating_add(RocksDbWeight::get().reads(3 as Weight))
			.saturating_add(RocksDbWeight::get().writes(4 as Weight))
	}
	// Storage: FileMap SchedulerMap (r:1 w:0)
	// Storage: Sminer MinerDetails (r:1 w:0)
	// Storage: FileBank FillerMap (r:0 w:100)
	fn upload_filler(_v: u32, ) -> Weight {
		(349_694_000 as Weight)
			.saturating_add(RocksDbWeight::get().reads(2 as Weight))
			.saturating_add(RocksDbWeight::get().writes(100 as Weight))
	}
	// Storage: FileBank File (r:1 w:1)
	// Storage: Sminer MinerDetails (r:1 w:1)
	// Storage: Sminer MinerItems (r:1 w:1)
	// Storage: Sminer TotalSpace (r:1 w:1)
	// Storage: Sminer AllMiner (r:1 w:1)
	// Storage: FileBank FillerMap (r:1 w:0)
	fn update_dupl() -> Weight {
		(163_897_000 as Weight)
			.saturating_add(RocksDbWeight::get().reads(6 as Weight))
			.saturating_add(RocksDbWeight::get().writes(5 as Weight))
	}
}